// Create global array to hold styles
var styles = new Array();

/************************************************************************
	Styles Management
*************************************************************************/	

// Adds styles to the sources collection
function RegisterStyle(style, isDefault)
{
	styles.push(style);
	
	// Set default source
	if(isDefault) styles.defaultStyle = style;
}

// Returns a style based on its name
function GetStyle(styleName, gauge)
{
	for(var i = 0; i < styles.length; i++)
	{
		if(styleName == styles[i].name) return styles[i];
	}
	
	gauge.style = "Wave";
	return styles.defaultStyle;
}

// Returns an array of available styles names
function GetStylesNames()
{
	var stylesNames = new Array();
	
	for(var i = 0; i < styles.length; i++)
	{
		stylesNames = stylesNames.concat(styles[i].name);
	}
	
	return stylesNames;
}

/************************************************************************
	Styles
*************************************************************************/	

function WaveStyle()
{
	this.name = "Wave";
	this.barsNumber = 10;
	
	this.labelPosition = new Object();
	
	this.labelPosition.right = {hOffset: 0, vOffset: 0};
	this.labelPosition.left = {hOffset: 0, vOffset: 0};
	this.labelPosition.top = {hOffset: 0, vOffset: 0};
	this.labelPosition.bottom = {hOffset: 0, vOffset: -1.1};
}

RegisterStyle(new WaveStyle(), true);

function MirroredWaveStyle()
{
	this.name = "Mirrored Wave";
	this.barsNumber = 10;
	
	this.labelPosition = new Object();
	
	this.labelPosition.right = {hOffset: 0, vOffset: 0};
	this.labelPosition.left = {hOffset: 0, vOffset: 0};
	this.labelPosition.top = {hOffset: 0, vOffset: 0};
	this.labelPosition.bottom = {hOffset: 0, vOffset: -1.1};
}

RegisterStyle(new MirroredWaveStyle());

function TargetStyle()
{
	this.name = "Target";
	this.barsNumber = 5;
	
	this.labelPosition = new Object();
	
	this.labelPosition.right = {hOffset: 0, vOffset: 0};
	this.labelPosition.left = {hOffset: 0, vOffset: 0};
	this.labelPosition.top = {hOffset: 0, vOffset: 0};
	this.labelPosition.bottom = {hOffset: 0, vOffset: 0};
}

RegisterStyle(new TargetStyle());

function HorizontalBarsStyle()
{
	this.name = "Horizontal Bars";
	this.barsNumber = 10;
	
	this.labelPosition = new Object();
	
	this.labelPosition.right = {hOffset: 0, vOffset: -1.8};
	this.labelPosition.left = {hOffset: 0, vOffset: -1.8};
	this.labelPosition.top = {hOffset: 0, vOffset: 0};
	this.labelPosition.bottom = {hOffset: 0, vOffset: -1.1};
}

RegisterStyle(new HorizontalBarsStyle());

function VerticalBarsStyle()
{
	this.name = "Vertical Bars";
	this.barsNumber = 10;
	
	this.labelPosition = new Object();
	
	this.labelPosition.right = {hOffset: 0, vOffset: 0};
	this.labelPosition.left = {hOffset: 0, vOffset: 0};
	this.labelPosition.top = {hOffset: 0, vOffset: 0};
	this.labelPosition.bottom = {hOffset: 0, vOffset: 0};
}

RegisterStyle(new VerticalBarsStyle());

function RainbowStyle()
{
	this.name = "Rainbow";
	this.barsNumber = 4;
	
	this.labelPosition = new Object();
	
	this.labelPosition.right = {hOffset: 0, vOffset: -1.2};
	this.labelPosition.left = {hOffset: 0, vOffset: -1.2};
	this.labelPosition.top = {hOffset: 0, vOffset: 0};
	this.labelPosition.bottom = {hOffset: 0, vOffset: 0};
}

RegisterStyle(new RainbowStyle());